<?php

namespace Drp\Analytics\Foundation;

use Drp\Analytics\Exceptions\InvalidPayload;

class AnalyticPayload
{
    private $data;

    /**
     * @param mixed $payload
     */
    public function __construct($payload)
    {
        $this->data = $this->normalise($payload);
    }

    public function getData(): array
    {
        return $this->data;
    }

    /**
     * @param mixed $payload
     */
    private function normalise($payload): array
    {
        if ($payload === null) {
            return [];
        }

        if ($payload instanceof self) {
            return $payload->getData();
        }

        if (is_array($payload)) {
            return $payload;
        }

        try {
            return json_decode($payload, true);
        } catch (\Throwable $exception) {
            throw new InvalidPayload();
        }
    }
}
