<?php

namespace Drp\Analytics\Foundation;

use Illuminate\Contracts\Auth\Authenticatable;
use Symfony\Component\HttpFoundation\Cookie;

class AnalyticableCookie
{
    public static function forUser(Authenticatable $user): Cookie
    {
        return cookie(
            config('analytics.cookie.name'),
            json_encode([
                'id' => $user->id,
                'type' => get_class($user),
            ]),
            config('analytics.cookie.lifetime') ?? config('session.lifetime')
        );
    }

    public static function pull(): ?array
    {
        return json_decode(request()->cookie(config('analytics.cookie.name')), true);
    }
}
