<?php

namespace Drp\Analytics\Foundation\Handlers;

use Drp\Analytics\Contracts\HandlesAnalytics;
use Drp\Analytics\Foundation\AnalyticPayload;
use Drp\Analytics\Foundation\AnalyticReference;
use Illuminate\Database\Eloquent\Collection;

class EloquentAnalytic implements HandlesAnalytics
{
    public function store(AnalyticReference $reference, AnalyticPayload $payload): void
    {
        $model = config('analytics.models.analytic');
        $analyticable = $reference->getAnalyticable();

        $model::create([
            'analyticable_id' => $analyticable['id'],
            'analyticable_type' => $analyticable['type'],
            'event' => $reference->getEvent(),
            'payload' => $payload->getData(),
        ]);
    }

    public function get(string $event, ?callable $query = null): Collection
    {
        $model = config('analytics.models.analytic');

        $baseQuery = $model::query()->whereEvent($event);

        if ($query === null) {
            return $baseQuery->get();
        }

        return $query($baseQuery)->get();
    }
}
